#!/usr/bin/env python
# encoding: utf-8

'''
PYTHON DLA INŻYNIERÓW
Lekcja: #5 Słowniki (Dictionary)

Copyright: www.oProjektowaniu.pl | 2019

Spis treści:
1. Tworzenie słownika
2. Operacje na słownikach
3. Metody wbudowane słowników
4. Zagnieżdżanie słowników
5. Przykład zastosowania słowików
'''


# ==========================================================================
# 1. Tworzenie słownika (dictionary)
# ==========================================================================

# Tworzenie słownika
moj_slownik = {'klucz1': 'wartosc1', 'klucz2': 'wartosc2'}

# SDefinicja pustego słownika i dodanie do niego elementów
moj_slownik = {}					# utworzenie pustego słownika
moj_slownik['klucz1'] = 'wartosc1'	# dodanie party klucz-wartość do słownika
moj_slownik['klucz2'] = 'wartosc2'

# Wyświetlenie słownika
print(moj_slownik)

# Definicja słownika zawierającego rózne typy danych
dict1 = {'key1': 'napis', 'key2': 123, 'key3': ['i1', 'i2', 'i3']}	# słownik zawierający różne typy danych


# Wywołanie wartości słownika
print(dict1['key3'])	# wywołanie elementu słownika

# Możemy też odwołać się do zagnieżdżonego elementu w słowniku.
print(dict1['key3'][0])


# ==========================================================================
# 2. Operacje na słownikach
# ==========================================================================

# --------------------------------------------------------------------------
# Dodawanie i zamiana elementów w słowniku
# --------------------------------------------------------------------------

dict1['key4'] = [11, 22, 33]	# dodanie nowego elementu do słownika para "klucz : wartość"
print(dict1)

# Modyfikacja wartości w słowniku
dict1['key4'] = 'nowa wartość'	# modyfikowanie wartości słownika
print(dict1)


# --------------------------------------------------------------------------
# Inne działania na słownikach
# --------------------------------------------------------------------------

dict1	# wywołanie słownika

# Modyfikacja elementów słownika
dict1['key2'] = dict1['key2'] - 100	# modyfikacja wartości w słowniku za pomocą odejmowania (nowa_wartość = stara_wartość - liczba)
print(dict1)

# Kilka innych przykładów modyfikacji słownika
print(dict1)	# wywołanie słownika

# Dodawanie napisu (ciągu znaków) do słownika
dict1['key1'] + ' nowy'
print(dict1['key1'])

# Powielanie elementu słownika
dict1['key3'] * 2
print(dict1['key3'])


# --------------------------------------------------------------------------
# Usuwanie elementu słownika
# --------------------------------------------------------------------------

del dict1['key3'] 	# usunięcie elementu za pomocą 'del'
print(dict1)

dict1.pop('key4')		# wywołanie i usunięcie elementu słownika za pomocą 'pop'
print(dict1)

# Aby wyczyścić cały słownik używamy metody `clear()`:
dict1.clear()
print(dict1)


# ==========================================================================
# 3. Metody wbudowane słowników
# ==========================================================================

dict1 = {'k1': 'w1', 'k2': 'w2'}	# zdefiniowanie słownika
print(dict1)

# Sprawdzanie liczby kluczy w słowniku
print(len(dict1))


# Zwracanie listy elementów słownika
print(dict1.items())	# wyświetlenie wszystkich elementów słownika: par klucz - wartość
print(dict1.keys())		# wyświetlenie wszystkich kluczy słownika
print(dict1.values())	# wyświetlenie wszystkich wartości słownika


# Aby zaktualizować słownik w oparciu o inny słownik używamy metody `update`:
dict2 = {'k10': 10}	# utworzenie drugiego słownika
dict1.update(dict2)	# aktualizacja słownika dict1 o słownik dict2
print(dict1)

# Inne operacje dostępne na słownikach
print(dir(dict1))


# ==========================================================================
# 4.  Zagnieżdżanie słowników
# ==========================================================================

# Definicja slownika zagniezdzonego
slownik_zagniezdzony = {'klucz1':{'pod_klucz':{'pod_pod_klucz': 'wartosc1'}}}
print(slownik_zagniezdzony)

# Wywołanie wartości zagnieżdżonego słownika
print(slownik_zagniezdzony['klucz1']['pod_klucz']['pod_pod_klucz'])


# ==========================================================================
# 5. Przykład zastosowania słowików
# ==========================================================================

# Klasy betonu wg EC2
concrete_fck = { 'C20/25': 20, 'C25/30': 25, 'C30/37': 30}
print(concrete_fck)

# I teraz łatwo można sprawdzić jaką wartość fck ma dana klasa betonu, np.:
print(concrete_fck['C25/30'])	# wywołanie watości fck odpowiadającej danej klasie betonu
